package com.jz.common.persistence;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.math.BigDecimal;
import java.security.Key;
import java.util.Base64;

@SuppressWarnings("restriction")
@Transactional(readOnly = true)
public class BaseService {

    protected Logger logger = LoggerFactory.getLogger(getClass());

    /*@Value("${spring.public-key}")
    private String publicKey;*/

    public BigDecimal format(Object obj) {
        BigDecimal bak = new BigDecimal(0);
        if (obj != null) {
            if (obj instanceof String) {
                if (StringUtils.isNotBlank((String) obj)) {
                    bak = new BigDecimal((String) obj);
                }
            } else if (obj instanceof Integer) {
                bak = new BigDecimal((Integer) obj);
            } else if (obj instanceof Double) {
                bak = new BigDecimal((Double) obj);
            } else if (obj instanceof Float) {
                bak = new BigDecimal((Float) obj);
            } else {
                bak = new BigDecimal(String.valueOf(obj));
            }
        }
        return bak;
    }

    public String encode(String pass,String publicKey) {
        String str = "";
        try {
            Key key = new SecretKeySpec(Base64.getMimeDecoder().decode(publicKey), "DESede");
            Cipher cipher = Cipher.getInstance("DESede");
            cipher.init(Cipher.ENCRYPT_MODE, key);
            str = Base64.getMimeEncoder().encodeToString(cipher.doFinal(pass.getBytes()));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return str;
    }

    public String decode(String pass,String publicKey) {
        String str = "";
        try {
            Key key = new SecretKeySpec(Base64.getMimeDecoder().decode(publicKey), "DESede");
            Cipher cipher = Cipher.getInstance("DESede");
            cipher.init(Cipher.DECRYPT_MODE, key);
            str = new String(cipher.doFinal(Base64.getMimeDecoder().decode(pass)));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return str;
    }

}
